makeup|SDK makeup|SDK is a library based on visage|SDK face tracking used to configure and render virtual makeup.

Loading...
Searching...
No Matches
Public Member Functions | List of all members
com.visagetechnologies.makeupsdk.Element Class Reference

## Public Member Functions
String | GetName ()
String | GetArea ()
String | GetTexture ()
Color | GetColor ()
void | SetArea (String area)
void | SetTexture (String texture)
void | SetColor (Color color)
JSONObject | ToJSON ()

## Detailed Description

Stores updatable rendering parameters of elements contained in a created makeup effect. Element instances are created from ElementTemplate instances attached to FeatureTemplate and or FinishTemplate used for creating the effect. Each ElementTemplate attached to both FeatureTemplate and FinishTemplate used to create the effect is mapped to a single Element.

Element is defined by the following:

- name : read-only member used for identification between different elements
- color : color of the rendered feature
- area : area where the rendering will be performed
- texture: path used to store color map of the feature
- useColor: parameter to determine if the coloring step will be performed in the pipeline.
- useTexture: parameter to determine if coloring step should use the provided color map stored in texture member.

Color is stored in Color class which contains a 4 dimensional vector specifying red, green, blue and alpha channels. Additionally, color can be provided as a path to a file containign color map to use.

Area is specified as a name of the image file that contains a greyscale image specifying how much of the color of this Element should be used at each fragment of the mesh used for rendering of the effect containing this Element. For each pixel in the area image, if the pixel is white 100% of color from this element will be used. If the pixel is black 100% of the color from the previous element will be used. The pixel values in between are lineraly interpolated.

Once an effect is created from a FeatureTemplate each ElementTemplate in the feature is mapped to one Element. The previous element of the first element in an effect is the output of the previous effect. If there are no previous effects displayed, the previous element is raw input image without augmentation.

The location where area images are stored is <path to platform dependent assets folder> + "/Textures/Area/" + Effect.type + Element.area where Effect.type is type of the effect containing this Element and Element.area is the area parameter of this Element. The location for storing of the color map is <path to platform dependent assets folder> + "/Textures/" + Element.texture.

Since both the area image and the color map are used as a texture on a mesh used for rendering the feature it will only work correctly if the uv mapping used on the mesh matches those images. This means that those images can be reused between effects only if the effects have the same type. Therefore, when specifying a new custom area image or a new color map, the image file needs to be placed in the subfolder specific to the type of the effect the new image was created for.

Additional files containing custom areas have to be added into the bundle and unpacked on the location defined above on the library consumer level.

The available meshes are stored in .obj format in the "Assets/Models" folder of the package. UV maps from these meshes should be used when creating new area images.

## Member Function Documentation

## ◆ GetArea()

String com.visagetechnologies.makeupsdk.Element.GetArea | ( |  | ) |
| inline

Returns the image file name specifying the area of the element.

Returns
  area of the element

## ◆ GetColor()

Color com.visagetechnologies.makeupsdk.Element.GetColor | ( |  | ) |
| inline

Returns the color of the element

Returns
  color of the element

## ◆ GetName()

String com.visagetechnologies.makeupsdk.Element.GetName | ( |  | ) |
| inline

Returns the name of the element

Returns
  name of the element

## ◆ GetTexture()

String com.visagetechnologies.makeupsdk.Element.GetTexture | ( |  | ) |
| inline

Returns the image file name specifying the texture of the element.

Returns
  texture of the element

## ◆ SetArea()

void com.visagetechnologies.makeupsdk.Element.SetArea | ( | String | area | ) |
| inline

Sets the image file name specifying the area of the element.

Parameters

  area | path to texture file specifying area to be used

## ◆ SetColor()

void com.visagetechnologies.makeupsdk.Element.SetColor | ( | Color | color | ) |
| inline

Sets the color of the element

Parameters

  color | Color object

## ◆ SetTexture()

void com.visagetechnologies.makeupsdk.Element.SetTexture | ( | String | texture | ) |
| inline

Sets the image file name specifying the texture of the element.

Parameters

  texture | path to texture file specifying texture to be used

## ◆ ToJSON()

JSONObject com.visagetechnologies.makeupsdk.Element.ToJSON | ( |  | ) |
| inline

Returns JSON object out of this Element object

Returns
  JSON representation of this Element returned as JSONObject